<?php
/*!
 * Copyright goodsmore <http://goodsmore.net/>
 * version 0.94
 * Dual licensed under the MIT and GPL licenses:
 * http://www.opensource.org/licenses/mit-license.php
 * http://www.gnu.org/licenses/gpl.html
 */

if ( ! function_exists('ajax_load') ) {
	function ajax_load( $selectors, $option, $search_parameter )
	{
		$array = array() ;
		if( ! function_exists( 'json_encode' ) ) {
			require_once( 'class/upgrade.php' ) ;
		}
		list( $result , $requests , $vars ) = get_requests( $search_parameter ) ;

		if ( ! empty ( $requests[ 'id' ] ) ) $array = array(
			'item_data' => get_item_xml( $requests[ 'id' ] ) ,
			'selectors' => $selectors ,
			'option'    => array_map( 'convert_to_utf' , $option ) ,
		) ;
		else if ( ! empty ( $result ) ) $array = get_items( $requests, $vars ) ;
		echo json_encode( $array ) ;
	}
}

if ( ! function_exists('get_requests') ) {
	function get_requests( $search_parameter )
	{
		$array = $vars = $replacements = array() ;
		$result = false ;

		$requests_int = array( 'id' ) ;
		$requests_text = array( 'type' , 'word' , 'tag' ,'category' , 'title' , 'sortorder' ) ;
		$parameter = array_keys( $search_parameter ) ;
		$check_key = array( 'word' , 'tag' ,'category' ) ;

		foreach( $requests_int as $key ) {
			$$key = ( ! empty( $_GET[ $key ] ) ) ? intval( @$_GET[ $key ] ) : 0 ;
		}
		if ( empty ( $id ) ) {
			foreach( $requests_text as $key ) {
				$$key = ( ! empty( $_GET[ $key ] ) ) ? trim( convert_to_utf( @$_GET[ $key ] ) ) : '' ;
			}
			foreach( $parameter as $key ) {
				$$key = ( preg_match( '`^[0-9]+$`' , $_GET[ $key ] ) ) ? intval( @$_GET[ $key ] ) : trim( convert_to_utf( @$_GET[ $key ] ) ) ;
				if ( ! empty ( $$key ) ) $replacements[ $key ] = $$key ;
			}
			if( ! function_exists( 'array_replace' ) ) {
				require_once( 'class/upgrade.php' ) ;
			}
			$vars = array_replace( $search_parameter, $replacements );
		}

		if ( ! empty ( $id ) ) $result = true ;
		else foreach( $check_key as $key ) {
			if ( ! empty ( $$key ) ) $result = true ;
		}

		$requests = array_merge( $requests_int, $requests_text, $parameter ) ;
		foreach( $requests as $key ) {
			$array[$key] = $$key ;
		}
		return array( $result , $array , $vars ) ;
	}
}

if ( ! function_exists('fetch_url') ) {
	function fetch_url( $target )
	{
	 	include_once( 'class/snoopy.php' ) ;
		$snoopy = new Snoopy() ;
		$snoopy->proxy_host = PROXY_HOST;
		$snoopy->proxy_port = PROXY_PORT ;
		$snoopy->proxy_user = PROXY_USER ;
		$snoopy->proxy_pass = PROXY_PASS ;
		$results = $snoopy->fetch( $target ) ;
		$xml = $snoopy->results ;
		return array( $xml, $results ) ;
	}
}

if ( ! function_exists('get_html') ) {
	function get_html( $id )
	{
		$target = 'http://www.moshimo.com/article/'.MOSHIMO_SHOP_ID.'/'.$id ;
		list( $html, $results ) = fetch_url( $target ) ;
		return ( ! empty ( $results ) ) ? convert( $html ) : '' ;
	}
}

if ( ! function_exists('return_xml') ) {
	function return_xml( $req )
	{
	 	include_once( 'class/xml.php' ) ;
		list( $xml, $results ) = fetch_url( $req ) ;
		$array = array() ;
		if ( ! empty ( $results ) ) $array = XML_unserialize( $xml ) ;
		return $array ;
	}
}

if ( ! function_exists('get_xml') ) {
	function get_xml( $req )
	{
		$array = return_xml( $req ) ;
		return ( ! empty ( $array ) ) ? $array['ArticleSearch'] : array() ;
	}
}

if ( ! function_exists('get_item_xml') ) {
	function get_item_xml( $id )
	{
		$file = 'cache/item_'.$id.'.php' ;
		if ( file_exists( $file ) && filemtime( $file ) + intval( CASHE_LIMIT ) > time() ) {
			$array = unserialize( join( '',file( $file ) ) ) ;
		} else {
			$req = 'http://api.moshimo.com/article/search' ;
			$req .= '?authorization_code='.AUTHORIZATION_CODE.'&article_id='.$id ;
			$req .= '&require_tag_list=1' ;
			$xml = get_xml( $req ) ;
			$rows = intval( $xml['Rows'] ) ;
			$array = ( ! empty( $rows ) ) ? make_item_cache( $xml, $file, $id ) : getStockStatusWord( $array, $id ) ;
		}
		return replaceArray( $array ) ;
	}
}

if ( ! function_exists('make_item_cache') ) {
	function make_item_cache( $xml, $file, $id )
	{
		$array = $xml['Articles']['Article'] ;
		$array = getaddArray( $array, $id ) ;
		$array['GroupItem'] = getGroupItem( $array ) ;
		makeCache( $array, $file ) ;
		return $array ;
	}
}

if ( ! function_exists('getDiscountRate') ) {
	function getDiscountRate( $array )
	{
		$fixedprice = intval( $array['FixedPrice'] ) ;
		$shopprice = intval( $array['ShopPrice'] ) ;
		$off = ( ! empty( $fixedprice ) && ( $fixedprice - $shopprice ) > 0 ) ? number_format( ( ( $fixedprice - $shopprice ) / $fixedprice ) * 100 ) : 0 ;
		return ( $off >= intval( LOWER_LIMIT_DISCOUNTRATE ) ) ? $off.'%' : '' ;
	}
}

if ( ! function_exists('getDiscount') ) {
	function getDiscount( $array )
	{
		$fixedprice = intval( $array['FixedPrice'] ) ;
		$shopprice = intval( $array['ShopPrice'] ) ;
		return ( ! empty( $fixedprice ) && ( $fixedprice - $shopprice ) > 0 ) ? $fixedprice - $shopprice : '' ;
	}
}

if ( ! function_exists('getFreeCarriage') ) {
	function getFreeCarriage( $array, $id )
	{
		if( $array['IsFreeShipping'] == 1 && intval( $array['ShopPrice'] ) < 8000 ) {
			$html = get_html( $id ) ;
			if ( ! empty( $html ) ) preg_match( '#<p class="free-shipping red">(.*?)</p>#', $html, $free ) ;
			return convert_to_utf( str_replace(  array( '&lt;', '&gt;'	) , array( '', '' ) , $free[1] ) ) ;
		} else {
			return ( $array['IsFreeShipping'] ==  1 ) ? convert_to_utf( FREECARRIAGE ) : '' ;
		}
	}
}

if ( ! function_exists('getDeliveryGuide') ) {
	function getDeliveryGuide( $array )
	{
		if( $array['PreorderFlag'] ) return convert_to_utf( PREORDERFLAG ) ;

		if( $array['IsDeliverySameday'] ) return convert_to_utf( ISDELIVERYSAMEDAY ) ;

		$guide = $array['DodFrom'] ;

		if( $array['DodFrom'] == 0 ) $guide = convert_to_utf( ISDELIVERYSAMEDAY ) ;

		if( $array['DodTo'] != $array['DodFrom'] ) $guide .= '&#65374;'. $array['DodTo'] . convert_to_utf( DELIVERYGUIDE ) ;
		else if( $array['DodFrom'] != 0 ) $guide .= convert_to_utf( DELIVERYGUIDE ) ;

		return convert_to_utf( $guide ) ;
	}
}

if ( ! function_exists('getBundle') ) {
	function getBundle( $array )
	{
		return ( $array['BundleImpossible'] ==  1 ) ? convert_to_utf( BUNDLE ) : '' ;
	}
}

if ( ! function_exists('getPayment') ) {
	function getPayment( $array )
	{
		switch( intval( $array['PaymentType'] ) ) {
			case 1 :
				return  convert_to_utf( PAYMENT_TYPE1 ) ;
			case 3 :
				return  convert_to_utf( PAYMENT_TYPE2 ) ;
		}
	}
}

if ( ! function_exists('getNewly') ) {
	function getNewly( $array )
	{
		return ( $array['IsNewly'] ==  1 ) ? convert_to_utf( NEWLY ) : '' ;
	}
}

if ( ! function_exists('getIsHeavySeller') ) {
	function getIsHeavySeller( $array )
	{
		return ( $array['HeavySeller'] ==  1 ) ? convert_to_utf( ISHEAVYSELLER ) : '' ;
	}
}

if ( ! function_exists('getNewIcon') ) {
	function getNewIcon( $array )
	{
		return ( $array['IsNewly'] ==  1 ) ? '<img src="'. NEW_ICON. '" alt="">'  : '' ;
	}
}

if ( ! function_exists('getPopIcon') ) {
	function getPopIcon( $array )
	{
		return ( $array['HeavySeller'] ==  1 ) ? '<img src="'. POP_ICON . '" alt="">'  : '' ;
	}
}

if ( ! function_exists('getFreeCarriageIcon') ) {
	function getFreeCarriageIcon( $array )
	{
		return ( $array['IsFreeShipping'] ==  1 ) ? '<img src="'. FREECARRIAGE_ICON . '" alt="">'  : '' ;
	}
}

if ( ! function_exists('getStockStatusWord') ) {
	function getStockStatusWord( $array, $id = 0 )
	{
		if( ! empty( $id ) ) {
			$array = array() ;
			$html = get_html( $id ) ;
			$str = ( strstr ( $html , 'title_sellouts.gif' ) ) ? convert_to_utf( SELLOUT ) : '' ;
			if( ! empty( $str ) ) $array['StockStatusWord'] = $str ;
			return $array ;
		} else {
			return ( intval( $array['StockStatus'] ) == 0 ) ? convert_to_utf( OUTOFSTOCK ) : $array['StockStatusWord'] ;
		}
	}
}

if ( ! function_exists('formatPrice') ) {
	function formatPrice( $val )
	{
		return convert_to_utf( sprintf( convert( PRICE_FORMAT ) , number_format( $val ) ) ) ;
	}
}

if ( ! function_exists('formatDiscountRate') ) {
	function formatDiscountRate( $val )
	{
		return convert_to_utf( sprintf( convert( DISCOUNTRATE_FORMAT ) , str_replace(  ' off' , '' , $val ) ) ) ;
	}
}

if ( ! function_exists('formatDiscount') ) {
	function formatDiscount( $val )
	{
		$price = ( strpos( $val , ',' ) === false ) ? number_format( $val ) : $val ;
		return convert_to_utf( sprintf( convert( DISCOUNT_FORMAT ) , $price ) ) ;
	}
}

if ( ! function_exists('formatDate') ) {
	function formatDate( $val )
	{
		list( $year, $month, $date ) = explode( '-', $val ) ;
		return convert_to_utf( date( convert( DATE_FORMAT ), mktime( 0, 0, 0, intval( $month ), intval( $date ), intval( $year ) ) ) ) ;
	}
}

if ( ! function_exists('getGroupItem') ) {
	function getGroupItem( $items )
	{
		$array = array() ;
		$i = 0 ;
		$id = intval( $items['GroupId'] ) ;
		if( ! empty( $id ) ) {
			$req = 'http://api.moshimo.com/article/search' ;
			$req .= '?authorization_code='.AUTHORIZATION_CODE.'&article_group_id='.$id ;
			$xml = get_xml( $req ) ;
			$rows = intval( $xml['Rows'] ) ;
			if( ! empty( $rows ) ) foreach ( $xml['Articles']['Article'] as $item ) {
				$array[$i] = $item ;
				$article_id = intval( $item['ArticleId'] ) ;
				$array[$i] = getaddArray( $item, $article_id, 0 ) ;
				$array[$i]['ItemHref'] = 'http://www.moshimo.com/article/'.MOSHIMO_SHOP_ID.'/'.$article_id ;
				$i++ ;
			}
		}
		return $array ;
	}
}

if ( ! function_exists('getCatchCopy') ) {
	function getCatchCopy( $array )
	{
		$searches = $replacements = array() ;
		$searches = array( 
			'#(")+#sU',
		) ;
		$replacements = array( 
			'',
		) ;
		return preg_replace( $searches, $replacements , $array['CatchCopy'] ) ;
	}
}

if ( ! function_exists('getaddArray') ) {
	function getaddArray( $array, $id, $needstockstatus = 1 )
	{
		$array['DiscountRate'] = getDiscountRate( $array ) ;
		$array['Discount'] = getDiscount( $array ) ;
		$array['FreeCarriage'] = getFreeCarriage( $array, $id ) ;
		$array['DeliveryGuide'] = getDeliveryGuide( $array ) ;
		$array['Bundle'] = getBundle( $array ) ;
		$array['Payment'] = getPayment( $array ) ;
		$array['Newly'] = getNewly( $array ) ;
		$array['IsHeavySeller'] = getIsHeavySeller( $array ) ;
		$array['NewIcon'] = getNewIcon( $array ) ;
		$array['PopIcon'] = getPopIcon( $array ) ;
		$array['FreeCarriageIcon'] = getFreeCarriageIcon( $array ) ;
		$array['CatchCopy'] = getCatchCopy( $array ) ;
		if( ! empty( $needstockstatus ) ) $array['StockStatusWord'] = getStockStatusWord( $array ) ;
		return $array ;
	}
}

if ( ! function_exists('replaceArray') ) {
	function replaceArray( $array )
	{
		foreach ( $array as $key=>$val ){
			if ( is_array( $val ) ) {
			 	$array[ $key ] = replaceArray( $array[ $key ] ) ;
			} else if ( ! empty ( $val ) ) {
				if ( strpos( $key , 'Price' ) > 0 ) $array[ $key ] = formatPrice( $val ) ;
				else if ( $key === 'DiscountRate' ) $array[ $key ] = formatDiscountRate( $val ) ;
			 	else if ( $key === 'Discount' )     $array[ $key ] = formatDiscount( $val ) ;
				else if ( $key === 'StartDate' )    $array[ $key ] = formatDate( $val ) ;
			}
		}
		return $array ;
	}
}

if ( ! function_exists('get_items') ) {
	function get_items( $requests, $search_parameter )
	{
		foreach ( $requests as $key=>$value ){
			$$key = $value ;
		}
		$name =  ( ! empty( $word ) ) ? substr( md5( $word ) , -6 ) : ( ( ! empty( $tag ) ) ? substr( md5( $tag ) , -6 ) : $category ) ;
		$order =  ( $type == 'ranking' ) ? '' : ( ( ! empty( $sortorder ) ) ? $sortorder : SEARCH_SORT_ORDER ) ;
		$file = 'cache/'.$type.'_'.$name.$order.'.php' ;
		if ( file_exists( $file ) && filemtime( $file ) + intval( CASHE_LIMIT ) > time() ) {
			$array = unserialize( join( '',file( $file ) ) ) ;
		} else {
			$array = make_items_cache( $type, $word, $tag, $category, $order, $search_parameter, $file ) ;
		}
		$title =  ( ! empty( $title ) ) ? convert( $title ) :
				( ( $type == 'ranking' ) ? convert( RANKING_TITLE ) : convert( SEARCH_TITLE ) ) ;
		$title =  ( ! empty( $word ) ) ? sprintf( $title,  convert( $word ) ) :
				( ( ! empty( $tag ) ) ? sprintf( $title , convert( $tag ) ) : sprintf( $title, getCategoryName( $category ) ) ) ;
		$option =  array(
			'title'     => convert_to_utf( $title ) ,
			'len'       => ( $type == 'ranking' ) ? intval( RANKING_LEN ) : intval( SEARCH_LEN ) ,
			'imageSize' => ( $type == 'ranking' ) ? RANKING_IMAGESIZE : SEARCH_IMAGESIZE ,
			'addkey'    => ( $type == 'ranking' ) ? RANKING_ADDKEY : SEARCH_ADDKEY ,
			'addclass'  => ( $type == 'ranking' ) ? RANKING_ADDCLASS : SEARCH_ADDCLASS ,
			'col'       => ( $type == 'ranking' ) ? intval( RANKING_COL ) : intval( SEARCH_COL ) ,
			'duration'  => ( $type == 'ranking' ) ? intval( RANKING_DURATION ) : intval( SEARCH_DURATION ) ,
		) ;
		return  array(
			'item_data' => replaceArray( $array ) ,
			'option'    => $option ,

		) ;
	}
}

if ( ! function_exists('make_items_cache') ) {
	function make_items_cache( $type, $word, $tag, $category, $order, $search_parameter, $file )
	{
		$array = array() ;
		$i = 0 ;
		$req = 'http://api.moshimo.com/article/search' ;
		$req .= '?authorization_code='.AUTHORIZATION_CODE ;
		switch( $type ) {
			case 'ranking':
				$req .= '&sort_order=sales' ;
				$req .= '&list_per_page='.intval( RANKING_LIMIT );
				$req .= '&exists_stock=1' ;
				$req .= '&field=name' ;
				break;
			case 'search':
				$req .= '&sort_order='.$order ;
				$req .= '&list_per_page='.intval( SEARCH_LIMIT );
				foreach ( $search_parameter as $key=>$value ){
					if ( ! empty( $value ) || $key === 'stock_status' ) $req .= '&'.$key.'='.urlencode( $value ) ;
				}
				break;
		}
		if ( ! empty( $word ) ) $req .= '&words='.urlencode( $word ) ;
		else if ( ! empty( $category ) ) $req .= '&article_category_code='.$category ;
		else if ( ! empty( $tag ) ) $req .= '&tags='.urlencode( $tag ) ;
		$xml = get_xml( $req ) ;
		$rows = intval( $xml['Rows'] ) ;
		$itemArray  = ( is_array( $xml['Articles']['Article'][0] ) ) ? $xml['Articles']['Article'] : $xml['Articles'] ;
		if( ! empty( $rows ) ) foreach ( $itemArray as $item ) {
			$array[$i] = $item ;
			$article_id = intval( $item['ArticleId'] ) ;
			$array[$i] = getaddArray( $item, $article_id, 0 ) ;
			$array[$i]['ItemHref'] = 'http://www.moshimo.com/article/'.MOSHIMO_SHOP_ID.'/'.$article_id ;
			$i++ ;
		}
		makeCache( $array, $file ) ;
		return $array ;
	}
}

if ( ! function_exists('getCategoryName') ) {
	function getCategoryName( $key )
	{
		$array = array() ;
		$file = 'cache/mosimo_category.cache' ;
		if ( file_exists( $file ) ) {
			$array = unserialize( join( '',file( $file ) ) ) ;
		} else {
			$req = 'http://api.moshimo.com/category/list' ;
			$req .= '?authorization_code='.AUTHORIZATION_CODE ;
			$categorylist = get_categorylist( $req ) ;
			$array = make_category_array( $array, $categorylist ) ;
			$parents = array_keys( $array ) ;
			foreach ( $parents as $id ) {
				$request = $req .'&article_category_code='.$id ;
				$categorylist = get_categorylist( $request ) ;
				$array = make_category_array( $array, $categorylist ) ;
			}
			makeCache( $array, $file ) ;
		}
		return ( ! empty ( $array ) ) ? $array[ $key ] : '' ;
	}
}

if ( ! function_exists('get_categorylist') ) {
	function get_categorylist( $req )
	{
		$array = return_xml( $req ) ;
		return ( ! empty ( $array ) ) ? $array['CategoryList'] : array() ;
	}
}

if ( ! function_exists('make_category_array') ) {
	function make_category_array( $array, $categorylist )
	{
		$rows = intval( $categorylist['Rows'] ) ;
		if ( ! empty( $rows ) ) foreach( $categorylist['Categories']['Category'] as $category ){
			$array[ $category['Code'] ] = trim( convert( $category['Name'] ) ) ;
		}
		return ( ! empty ( $array ) ) ? $array : array() ;
	}
}

if ( ! function_exists('makeCache') ) {
	function makeCache( $value, $file )
	{
		if ( cacheDirCheck() && $fp = @fopen( $file , 'wb' ) ) {
			fputs( $fp, serialize( $value ) ) ;
			fclose( $fp ) ;
		}
	}
}

if ( ! function_exists('cacheDirCheck') ) {
	function cacheDirCheck()
	{
		$result = true ;
		$dir = 'cache' ;
		$safe_mode = ini_get( 'safe_mode' ) ;
		if( ! is_dir( $dir ) ) {
			if( $safe_mode ) $result = false ;
			$mrs = mkdir( $dir , 0777 ) ;
			if( ! $mrs ) $result = false ;
			else @chmod( $dir , 0777 ) ;
		}
		if( ! is_writable( $dir ) || ! is_readable( $dir ) ) {
			$mrs = chmod( $dir , 0777 ) ;
			if( ! $mrs ) $result = false ; ;
		}
		if( is_writable( $dir ) ) removeCache() ;
		return $result ;
	}
}

if ( ! function_exists('removeCache') ) {
	function removeCache()
	{
		$dirname   = 'cache' ;
		$limitTime = intval( CASHE_LIMIT ) * 10 ;

		if ( $handle = opendir( $dirname ) ) {
			while ( false !== ( $file = readdir( $handle ) ) ) {
				if ( ! preg_match( '#^[\.]{1,2}$#', $file ) && preg_match( '#\.php$#i', $file ) ) {
					if ( ( time() - fileatime( $dirname . '/' . $file ) ) > $limitTime ) {
						@unlink( $dirname . '/' . $file ) ;
					}
				}
			}
			closedir( $handle ) ;
			clearstatcache();
		}
	}
}

if ( ! function_exists('convert') ) {
	function convert( $str ) {
		return mb_convert_encoding( $str, mb_internal_encoding(), 'auto' ) ;
	}
}

if ( ! function_exists('convert_to_utf') ) {
	function convert_to_utf( $str ) {
		return mb_convert_encoding( $str, 'UTF-8', 'auto' ) ;
	}
}

?>